Index: trunk/FACT++/dim/README_v20.txt
===================================================================
--- trunk/FACT++/dim/README_v20.txt	(revision 14580)
+++ trunk/FACT++/dim/README_v20.txt	(revision 14698)
@@ -1,4 +1,4 @@
 
-                    DIM version 20r2 Release Notes
+                    DIM version 20r4 Release Notes
 
 Notes 1 and 2 for Unix Users only
@@ -17,5 +17,20 @@
 		Dns </dev/null >& dns.log &
 
-NOTE 3: The Version Number service provided by servers is now set to 2002.
+NOTE 3: The Version Number service provided by servers is now set to 2004.
+
+21/11/2012
+Changes for version 2004:
+    - WebDid did not compile under SLC5, fixed.
+    - Removed several Compiler warnings under SLC5
+
+
+20/11/2012
+Changes for version 2003:
+    - Added the project settings for Visual Studio 10 in the Visual directory
+    - Added a prototype webDid. in order to use it:
+	- In the same machine when the DIM DNS runs start <dim>/WebDid/webDid
+	- In any machine from where the DIM DNS is reacheable on your favorite Web browser use as URL:
+		http://<DIM DNS node name>:2500 
+
 
 07/11/2012
Index: trunk/FACT++/dim/dim/dim.h
===================================================================
--- trunk/FACT++/dim/dim/dim.h	(revision 14580)
+++ trunk/FACT++/dim/dim/dim.h	(revision 14698)
@@ -14,5 +14,5 @@
 #include "dim_common.h"
 
-#define DIM_VERSION_NUMBER 2002
+#define DIM_VERSION_NUMBER 2004
 
 
Index: trunk/FACT++/dim/src/did/did.c
===================================================================
--- trunk/FACT++/dim/src/did/did.c	(revision 14580)
+++ trunk/FACT++/dim/src/did/did.c	(revision 14698)
@@ -1457,8 +1457,10 @@
 {
 int i,j;
-char *asc, *ptr, str[80], tmp[256];
+char *ptr, str[80], tmp[256];
 int last[4];
-
+/*
+char *asc;
 	asc = (char *)buff;
+*/
 	ptr = Service_content_str;
 	ptr += strlen(Service_content_str);
@@ -1512,5 +1514,7 @@
 			}
 			strcat(tmp,"\n");
+/*
 			asc = (char *)&buff[i+1];
+*/
 		}
 		strcpy(ptr, tmp);
@@ -1524,8 +1528,10 @@
 {
 int i,j;
-char *asc, *ptr, str[80], tmp[256];
+char *ptr, str[80], tmp[256];
 longlong last[4];
-
+/*
+char *asc;
 	asc = (char *)buff;
+*/
 	ptr = Service_content_str;
 	ptr += strlen(Service_content_str);
@@ -1558,5 +1564,7 @@
 			}
 			strcat(tmp,"\n");
+/*
 			asc = (char *)&buff[i+1];
+*/
 		}
 		strcpy(ptr, tmp);
@@ -1570,8 +1578,10 @@
 {
 int i,j;
-char *asc, *ptr, str[80], tmp[256];
+char *ptr, str[80], tmp[256];
 short last[8];
-
+/*
+char *asc; 
 	asc = (char *)buff;
+*/
 	ptr = Service_content_str;
 	ptr += strlen(Service_content_str);
@@ -1625,5 +1635,7 @@
 			}
 			strcat(tmp,"\n");
+/*
 			asc = (char *)&buff[i+1];
+*/
 		}
 		strcpy(ptr, tmp);
@@ -1638,6 +1650,7 @@
 int i,j;
 char *asc, *ptr, str[80], tmp[256];
+/*
 char last[16];
-
+*/
 	asc = (char *)buff;
 	ptr = Service_content_str;
@@ -1662,6 +1675,6 @@
 		strcat(tmp," ");
 		strcat(tmp,&str[strlen(str)-2]);
+		/*
 		last[i%16] = buff[i];
-		/*
 		if(i%4 == 3)
 		  strcat(tmp," ");
@@ -2627,5 +2640,8 @@
 {
 Arg arglist[10];
-int n, n_services = -1;
+int n;
+/*
+int n_services = -1;
+*/
 Widget w, ww, w_id;
 void activate_services(), activate_clients();
@@ -2633,6 +2649,8 @@
 	
 	w_name[0] = 0;
+/*
 	if(servp)
 		n_services = servp->server.n_services;
+*/
     strcpy(w_name,name);
 	if(strlen(w_name) >= MAX_TASK_NAME - 4)
@@ -2912,13 +2930,14 @@
 int i = 0;
 char str[2048], *strp, *strp1;
-DNS_SERVER_INFO *ptr;
 XmString xstr;
 void delete_str();
 
+/*
+DNS_SERVER_INFO *ptr;
 	ptr = &servp->server;
-	/*
 	sel_id = servp->pop_widget_id[1];
 	id = (Widget)XmSelectionBoxGetChild(sel_id,XmDIALOG_LIST_LABEL);
-	*/
+*/
+	if(servp){}
 	if(Curr_client_list[0] == -1) 
 	{
@@ -2980,5 +2999,7 @@
 void activate_clients(Widget w, SERVER *servp, unsigned long *reason)
 {
+/*
 DNS_SERVER_INFO *ptr;
+*/
 char str[100];
 void show_clients();
@@ -2989,5 +3010,7 @@
 	if(reason){}
 	Curr_servp = servp;
+/*
 	ptr = &servp->server;
+*/
 	if(servp->pop_widget_id[1])
 	  {
@@ -3108,5 +3131,7 @@
 {
 	static int old_n_services = 0;
+/*
 	static int changing = 0;
+*/
 	void put_label();
 
@@ -3115,6 +3140,8 @@
 	{
 		put_label();
+/*
 		if(N_services > old_n_services)
 		  changing = 1;
+*/
 		old_n_services = N_services;
 	
Index: trunk/FACT++/dim/src/dim_thr.c
===================================================================
--- trunk/FACT++/dim/src/dim_thr.c	(revision 14580)
+++ trunk/FACT++/dim/src/dim_thr.c	(revision 14698)
@@ -113,5 +113,4 @@
 	pthread_t t_id;
 	void ignore_sigpipe();
-	int ret;
 	extern int dna_init();
 /*
@@ -162,7 +161,7 @@
 #endif
 #ifndef darwin
-		ret = sem_wait(&DIM_INIT_Sema);
-#else
-		ret = sem_wait(DIM_INIT_Semap);
+		sem_wait(&DIM_INIT_Sema);
+#else
+		sem_wait(DIM_INIT_Semap);
 #endif
 #if defined (LYNXOS) && !defined (__Lynx__)
@@ -172,7 +171,7 @@
 #endif
 #ifndef darwin
-		ret = sem_wait(&DIM_INIT_Sema);
-#else
-		ret = sem_wait(DIM_INIT_Semap);
+		sem_wait(&DIM_INIT_Sema);
+#else
+		sem_wait(DIM_INIT_Semap);
 #endif
 		INIT_thread = 0;
Index: trunk/FACT++/dim/src/dns.c
===================================================================
--- trunk/FACT++/dim/src/dns.c	(revision 14580)
+++ trunk/FACT++/dim/src/dns.c	(revision 14698)
@@ -179,6 +179,4 @@
 	DNS_DIS_PACKET dis_packet;
 	int i, service_id;
-	int format;
-	DNS_CONNECTION *connp;
 	int n_services;
 	char *ptr, *ptr1, *ptrt;
@@ -192,4 +190,7 @@
 #ifdef WIN32
 	extern int time();
+#endif
+#ifdef VMS
+	int format;
 #endif
 	int update_did = 0;
@@ -369,6 +370,6 @@
 				dis_packet.type = htovl(DNS_DIS_KILL);
 				dis_packet.size = htovl(DNS_DIS_HEADER);
+#ifdef VMS
 				format = vtohl(packet->format);
-#ifdef VMS
 				if((format & MY_OS9) || (servp->state == -1))
 				{
@@ -480,5 +481,4 @@
 						Curr_n_services--;
 						free(servp);
-						connp = &Dns_conns[conn_id];
 						Dns_conns[conn_id].n_services--;
 						if( dll_empty((DLL *) Dns_conns[conn_id].service_head))
@@ -943,5 +943,4 @@
 	int n_informed = 0;
 	static DNS_SERVICE *prev_servp = (DNS_SERVICE *)0;
-	static int n_times = 0;
 	void inform_clients();
 
@@ -976,5 +975,4 @@
 		}
 	}
-	n_times = 0;
 	prev_servp = (DNS_SERVICE *)0;
 	ENABLE_AST
@@ -1079,8 +1077,6 @@
 	DNS_SERVICE *servp, *old_servp;
 	NODE *nodep, *old_nodep;
-	DNS_CONNECTION *connp;
 	void service_remove();
 
-	connp = &Dns_conns[conn_id];
 	if( Dns_conns[conn_id].src_type == SRC_DIS ) 
 	{
Index: trunk/FACT++/dim/src/examples/test_client.cxx
===================================================================
--- trunk/FACT++/dim/src/examples/test_client.cxx	(revision 14580)
+++ trunk/FACT++/dim/src/examples/test_client.cxx	(revision 14698)
@@ -45,5 +45,5 @@
 	}
 public :
-	StrService() : DimInfo("TEST/STRVAL","not available") {};
+	StrService() : DimInfo("TEST/STRVAL",(char *)"not available") {};
 };
 
Index: trunk/FACT++/dim/src/examples/test_server.c
===================================================================
--- trunk/FACT++/dim/src/examples/test_server.c	(revision 14580)
+++ trunk/FACT++/dim/src/examples/test_server.c	(revision 14698)
@@ -64,5 +64,5 @@
 int main(int argc, char **argv)
 {
-	int i, id, *ptr/*, big_ids[20]*/;
+	int i, id/*, big_ids[20]*/;
 	char aux[80];
 	char name[84]/*, name1[132]*/;
@@ -97,4 +97,5 @@
 	if(new_dns)
 		dnsid = dis_add_dns(extra_dns,0);
+	if(dnsid){}
 /*
 	buf_sz = dim_get_write_buffer_size();
@@ -120,5 +121,4 @@
 	t.c = 'a';
 	t.f = (float)4.56;
-	ptr = (int *)&t;
 	strcpy(t.str,"hello world");
 
Index: trunk/FACT++/dim/src/examples/test_server.cxx
===================================================================
--- trunk/FACT++/dim/src/examples/test_server.cxx	(revision 14580)
+++ trunk/FACT++/dim/src/examples/test_server.cxx	(revision 14698)
@@ -57,5 +57,5 @@
 public :
 	CmndServ() : DimCommand("TEST/CMND","C"), 
-				 servstr("TEST/STRVAL","empty") {};
+				 servstr("TEST/STRVAL",(char *)"empty") {};
 /*
 	void handleIt()
@@ -88,4 +88,5 @@
 
 	abc = new DimService("TEST/INTVAL_CONST",(int &)ival);
+	if(abc){}
 }
 
@@ -95,4 +96,5 @@
 
 	abc = new DimService("TEST/STRINGVAL_CONST",(char *)s1.c_str());
+	if(abc){}
 }
 
@@ -136,7 +138,7 @@
 
 	DimServer::start("TEST");
-	extraDns = DimUtil::getEnvVar("EXTRA_DNS_NODE");
+	extraDns = DimUtil::getEnvVar((char *)"EXTRA_DNS_NODE");
 	if(extraDns)
-		newDns = new DimServerDns(extraDns, 0, "new_TEST");
+		newDns = new DimServerDns(extraDns, 0, (char *)"new_TEST");
 
 /*
@@ -163,5 +165,6 @@
 	CmndServ cmdsvr;
 
-	testServ = new ServWithHandler("MY_NEW_TEST_SERVICE_WITH_HANDLER");
+	testServ = new ServWithHandler((char *)"MY_NEW_TEST_SERVICE_WITH_HANDLER");
+	if(testServ){}
 
 //	farr[0] = 1.2;
Index: trunk/FACT++/dim/src/util/check_dim_servers.cxx
===================================================================
--- trunk/FACT++/dim/src/util/check_dim_servers.cxx	(revision 14580)
+++ trunk/FACT++/dim/src/util/check_dim_servers.cxx	(revision 14698)
@@ -58,4 +58,5 @@
 	  strcat(serviceName,"/VERSION_NUMBER");
 	  srvptr = new DimVersion(serviceName, index);
+	  if(srvptr){}
 	  //	  cout << "found " << server << " " << node << endl;
 	  index++;